
#define HSIZE (1000)	// nbVe[uTCY

struct NODE{
	char id[40];			//m[hID
	double lat;				//ܓx
	double lon;				//ox
	int state;				//_CNXg@ŗpԕϐ
	double mincost;			//_CNXg@ŗpŏRXg
	struct LINK* beforelink;	//_CNXg@ŗpON
	struct LINKLIST* nextlinklist;	//̃m[hN_Ƃ郊N
	struct NODE* next;
};

struct LINK{
	char id[40];			//NID
	struct NODE *o;			//N_m[h
	struct NODE *d;			//I_m[h
	double length;			//N
	double speed;			//x
	double freecost;		//R̃RXg
	double cost;			//RXg
	double capacity;		//ʗe
	double flow;			//ʗ
	double newflow;			//vZōXVʗ
	struct LINK* next;
};

struct LINKLIST{
	struct LINK *link;
	struct LINKLIST* next;
};

struct NETWORK{
	struct LINK* link[HSIZE];
	struct NODE* node[HSIZE];
};


struct NETWORK* set_networks();
int hash(char* str);
struct NODE* search_node(char* id, struct NETWORK *p);
struct LINK* search_link(char* id, struct NETWORK *p);
struct NODE* search_onode(struct NETWORK *p, double lat, double lon);
struct NODE* search_dnode(struct NETWORK *p, double lat, double lon);
double distance(double alat, double alon, double blat, double blon);
struct LINKLIST *dijkstra(struct NETWORK *network, struct NODE *o, struct NODE *d);
